/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.C
* Author             : MJX
* Version            : V1.20
* Date               : 2015/08/28
* Description        : CH378 ļϵͳӳ(EXAM10)
*                      USB Host File Interface for CH378
*					   TC2.0@PC, KC7.0@MCS51
*******************************************************************************/



/******************************************************************************
˵: 
    MCS-51ƬCԵUļдʾ
    ʾļĿ¼,: ޸ļ,ļĴںʱ
    ļ޸ںʱ.
*******************************************************************************/



/*******************************************************************************/
/* ͷļ */
#include <reg52.h>
#include <stdio.h>
#include <string.h>
#include "CH378INC.H"											 /* CH378ͷļ */	
#include "HAL.H"												 /* Ӳͷļ */
#include "HAL_BASE.C"											 /* Ӳӳļ */
#include "DEBUG.H"												 /* ӳͷļ */
#include "DEBUG.C"												 /* ӳļ */

/*******************************************************************************/
/* ѡͨѶӿ */
#define	IC_OP_INTERFACE_MODE	 2							 	 /* оƬӿģʽ(1:Ӳ;  2:ģⲢ; 
                                                                    	                 3:ӲSPI; 4:ģSPI; 5:첽) */                                                                    
#if    ( IC_OP_INTERFACE_MODE == 1 )
#include "PARA_HW.C"											 /* Ӳ߲ӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 2 )
#include "PARA_SW.C"										 	 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
#include "SPI_HW.C"										 	 	 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
#include "SPI_SW.C"												 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
#include "UART_HW.C"										 	 /* Ӳ첽ӷʽ */
#else
#error: You Must Include Right Interface Operate File!!!
#endif

/*******************************************************************************/
/* ѡҪĺ */
//#define EN_DISK_QUERY		  	   1							 /* ѯʣռѯӳ */
//#define EN_DIR_CREATE			   1							 /* ½༶Ŀ¼ӳ */	
//#define EN_SECTOR_ACCESS   	   1							 /* Ϊλдļӳ */		
//#define EN_LONG_NAME	   		   1							 /* ֳ֧ļӳ */		
//#define EN_OTHER_FUNCTION   	   1							 /* ǳӳ */		

#include "FILE_SYS.H"											 /* ļϵͳͷļ */
#include "FILE_SYS.C"											 /* ļϵͳӳļ */

/*******************************************************************************/
/*  */
UINT16 SecterSize;												 /* ǰUÿС */  
UINT8  idata buf[ 64 ];											 /* ݻ */	

/*******************************************************************************
* Function Name  : RenameFileName
* Description    : ޸ָļļ
*                  нCļ޸ΪTXTļ
* Input          : iOldName---Ҫ޸ĵԭʼļ
* Output         : None
* Return         : ERR_SUCCESSʾ޸ļɹ
*******************************************************************************/               
UINT8 RenameFileName( PUINT8 iOldName )
{
	UINT8  status;
	P_FAT_DIR_INFO	pDir;

	status = CH378FileOpen( iOldName );  						 /* ļ */
	if( status == ERR_SUCCESS ) 
	{
		/* ļдȲ... */
		status = CH378DirInfoRead( 0xFF );  					 /* ȡǰļĿ¼ϢFAT_DIR_INFO,ݵڴ */
		if( status == ERR_SUCCESS ) 
		{
			CH378ReadReqBlock( buf );		
			pDir = (P_FAT_DIR_INFO)buf;  						 /* ǰļĿ¼Ϣ */
			if( ( pDir -> DIR_Name[ 8 ] == 'C' ) && ( pDir -> DIR_Name[ 9 ] == ' ' ) ) 
			{  
				/* ļչC */
				pDir -> DIR_Name[ 8 ] = 'T';  					 /* ޸ļչΪTXT */
				pDir -> DIR_Name[ 9 ] = 'X';  					 /* ͬ޸ļ */
				pDir -> DIR_Name[ 10 ] = 'T';

				CH378WriteOfsBlock( buf, 0x00, 32 ); 
				status = CH378DirInfoSave( 0xFF );  			 /* ļĿ¼Ϣ */
				if( status == ERR_SUCCESS ) 					 /* ɹ޸Ĳ */
				{  
					/* ļдȲ... */
				}
			}
			else 
			{  
				/* ļչC */
			}
		}
		CH378FileClose( FALSE );  								 /* رļ */
	}
	return( status );
}
               
/*******************************************************************************
* Function Name  : SetFileCreateTime
* Description    : ָļĴںʱ
* Input          : iFileName-----ļ
*                  iCreateDate---µĴ
*                  iCreateTime---µĴʱ
* Output         : None
* Return         : ERR_SUCCESSʾ޸ļɹ
*******************************************************************************/                
UINT8 SetFileCreateTime( PUINT8 iFileName, UINT16 iCreateDate, UINT16 iCreateTime )
{
	UINT8  status;
	P_FAT_DIR_INFO	pDir;

	status = CH378FileOpen( iFileName );  						 /* ļ */
	if( status == ERR_SUCCESS ) 
	{
		/* ļдȲ... */
		status = CH378DirInfoRead( 0xFF );  					 /* ȡǰļĿ¼ϢFAT_DIR_INFO,ݵڴ */
		if( status == ERR_SUCCESS ) 
		{
			CH378ReadReqBlock( buf );		
			pDir = (P_FAT_DIR_INFO)buf;  				
			buf[ STRUCT_OFFSET( FAT_DIR_INFO, DIR_CrtTime ) ] = (UINT8)iCreateTime;  		  /* ļʱ,8λǰ */
			buf[ STRUCT_OFFSET( FAT_DIR_INFO, DIR_CrtTime ) + 1 ] = (UINT8)(iCreateTime>>8);  /* ļʱ,8λں */
			buf[ STRUCT_OFFSET( FAT_DIR_INFO, DIR_CrtDate ) ] = (UINT8)iCreateDate;  	      /* ļ,8λǰ */
			buf[ STRUCT_OFFSET( FAT_DIR_INFO, DIR_CrtDate ) + 1 ] = (UINT8)(iCreateDate>>8);  /* ļ,8λں */
			CH378WriteOfsBlock( buf, 0x00, 32 ); 
			status = CH378DirInfoSave( 0xFF );  			 	 /* ļĿ¼Ϣ */
			if( status == ERR_SUCCESS ) 					 	 /* ɹ޸Ĳ */
			{  
				/* ļдȲ... */
			}

		}
		CH378FileClose( FALSE );  								 /* رļ */
	}
	return( status );		
}

/*******************************************************************************
* Function Name  : SetFileModifyTime
* Description    : ָļ޸ںʱ
*                  ע⣺ҲԲοĺ޸ 
* Input          : iFileName-----ļ
*                  iModifyDate---µ޸
*                  iModifyTime---µ޸ʱ
* Output         : None
* Return         : ERR_SUCCESSʾ޸ļɹ
*******************************************************************************/                
UINT8 SetFileModifyTime( PUINT8 iFileName, UINT16 iModifyDate, UINT16 iModifyTime )
{
	UINT8  status;
	
	status = CH378FileOpen( iFileName );  						 /* ļ */
	if( status == ERR_SUCCESS ) 
	{	
		status = CH378FileModify( 0xFFFFFFFF, iModifyDate, iModifyTime, 0xFF );
		if( status == ERR_SUCCESS )				
		{
			/* ļдȲ... */
		}		
		status = CH378FileClose( FALSE );  						 /* رļ */
	}
	return( status );
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void main( void ) 
{
	UINT8  status;
	UINT16 i;
	
	mDelaymS( 100 );  											 /* ʱ100 */
	mInitSTDIO( );  											 /* Ϊüͨڼʾ */

#if    ( IC_OP_INTERFACE_MODE == 1 )
	printf(" MCS51_CH378_PARA_HW V1.2 2015.08.28...\n");		 /* Ӳ߲ӷʽ */						 			 
#elif  ( IC_OP_INTERFACE_MODE == 2 )
	printf(" MCS51_CH378_PARA_SW V1.2 2015.08.28...\n"); 		 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
	printf(" MCS51_CH378_SPI_HW V1.2 2015.08.28...\n"); 		 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
	printf(" MCS51_CH378_SPI_SW V1.2 2015.08.28...\n");			 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
	printf(" MCS51_CH378_UART_HW V1.2 2015.08.28...\n");		 /* Ӳ첽ӷʽ */
#else
	printf(" MCS51_CH378_INTERFACE ERROR 2015.08.28...\n");
#endif

	status = mInitCH378Host( );  								 /* ʼCH378 */								 	
	mStopIfError( status );
	/* ·ʼ */

	while( 1 ) 													 
	{
		/* U̻SDǷ,ȴ */
		printf( "Wait Udisk/SD\n" );
		while( CH378DiskConnect( ) != ERR_SUCCESS ) 
		{  
			mDelaymS( 100 );
		}
		mDelaymS( 200 );  										 /* ʱ,ѡ,еUSB洢Ҫʮʱ */
		
		/* ڼ⵽USB豸,ȴ100*50mS,ҪЩMP3̫,ڼ⵽USB豸DISK_MOUNTED,
		   ȴ5*50mS,ҪDiskReady */
		for( i = 0; i < 100; i ++ ) 
		{  
			/* ȴʱ,100*50mS */
			mDelaymS( 50 );
			printf( "Ready ?\n" );
			status = CH378DiskReady( );  						 /* ʼ̲ԴǷ */
			if( status == ERR_SUCCESS ) 
			{
				break;  										 /* ׼ */
			}
			else if( status == ERR_DISK_DISCON ) 
			{
				goto UnknownUsbDevice; 							 /* ⵽Ͽ,¼Ⲣʱ */
			}
			if( CH378GetDiskStatus( ) >= DEF_DISK_MOUNTED && i >= 5 ) 
			{
				break;  										 /* еUǷδ׼,Ժ,ֻҪ佨MOUNTEDҳ5*50mS */
			}
		}
		if( status == ERR_DISK_DISCON ) 
		{  
			/* ⵽Ͽ,¼Ⲣʱ */
			printf( "Device gone\n" );
			continue;
		}
		if( CH378GetDiskStatus( ) < DEF_DISK_MOUNTED ) 
		{  
			/* δ֪USB豸,USB̡ӡ */
			printf( "Unknown device\n" );
			goto UnknownUsbDevice;
		}
		
		/* Ҫ,ԶȡݿCH378_CMD_DATA.DiskMountInq,س */
		i = CH378ReadReqBlock( buf );
		if( i == sizeof( INQUIRY_DATA ) ) 
		{  
			/* U̵ĳ̺ͲƷϢ */
			buf[ i ] = 0;
			printf( "Udisk Info: %s\n", ((P_INQUIRY_DATA)buf) -> VendorIdStr );
		}

		/* ȡǰUС(Ҫʹ) */
		SecterSize = 1 << CH378ReadVar8( VAR8_DISK_SEC_LEN );		/* ǰUÿС */  

		/* ޸ļʾ(ڸĿ¼, CH378HFT.CļΪCH378HFT.TXTļ) */
		printf( "Open And Rename CH378HFT.C to CH378HFT.TXT \n" );
		status = RenameFileName( "/CH378HFT.C" );  
		if( status == ERR_SUCCESS )
		{
			printf( "File Name Change Success!!!\n" );			
		}	
		if( status == ERR_MISS_FILE ) 
		{
			printf( "File /CH378HFT.C Not Found !\n" );
		}
		mStopIfError( status );
		
		/* ޸ļĴںʱʾ */
		printf( "Set File Create Date & Time To 2010.07.08 10:39:20 \n" );
		status = SetFileCreateTime( "/CH378HFT.TXT", MAKE_FILE_DATE( 2010, 7, 8 ), MAKE_FILE_TIME( 10, 39, 20 ) );  
		mStopIfError( status );

		/* ޸ļ޸ںʱʾ */
		printf( "Set File Modify Date & Time To 2012.06.15 08:30:45 \n" );
		status = SetFileModifyTime( "/CH378HFT.TXT", MAKE_FILE_DATE( 2012, 6, 15 ), MAKE_FILE_TIME( 8, 30, 45 ) );  
		mStopIfError( status );

UnknownUsbDevice:
		printf( "Take out\n" );
		while( CH378DiskConnect( ) == ERR_SUCCESS ) 
		{  
			/* UǷ,ȴṴγ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );
	}
}


