/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.C
* Author             : MJX
* Version            : V1.20
* Date               : 2015/08/28
* Description        : CH378 ļϵͳӳ(EXAM12)
*                      USB Host File Interface for CH378
*					   TC2.0@PC, KC7.0@MCS51
*******************************************************************************/



/******************************************************************************
˵: 
    MCS-51ƬCԵUļдʾ
    ʾUǷд,ʾģ˵İȫƳ,ҲԲο
    .
*******************************************************************************/



/*******************************************************************************/
/* ͷļ */
#include <reg52.h>
#include <stdio.h>
#include <string.h>
#include "CH378INC.H"											 /* CH378ͷļ */	
#include "HAL.H"												 /* Ӳͷļ */
#include "HAL_BASE.C"											 /* Ӳӳļ */
#include "DEBUG.H"												 /* ӳͷļ */
#include "DEBUG.C"												 /* ӳļ */

/*******************************************************************************/
/* ѡͨѶӿ */
#define	IC_OP_INTERFACE_MODE	 2							 	 /* оƬӿģʽ(1:Ӳ;  2:ģⲢ; 
                                                                    	                 3:ӲSPI; 4:ģSPI; 5:첽) */                                                                    
#if    ( IC_OP_INTERFACE_MODE == 1 )
#include "PARA_HW.C"											 /* Ӳ߲ӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 2 )
#include "PARA_SW.C"										 	 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
#include "SPI_HW.C"										 	 	 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
#include "SPI_SW.C"												 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
#include "UART_HW.C"										 	 /* Ӳ첽ӷʽ */
#else
#error: You Must Include Right Interface Operate File!!!
#endif

/*******************************************************************************/
/* ѡҪĺ */
//#define EN_DISK_QUERY		   	   1							 /* ѯʣռѯӳ */
//#define EN_DIR_CREATE			   1							 /* ½༶Ŀ¼ӳ */	
//#define EN_SECTOR_ACCESS   	   1							 /* Ϊλдļӳ */		
//#define EN_LONG_NAME	   		   1							 /* ֳ֧ļӳ */		
//#define EN_OTHER_FUNCTION   	   1							 /* ǳӳ */		

#include "FILE_SYS.H"											 /* ļϵͳͷļ */
#include "FILE_SYS.C"											 /* ļϵͳӳļ */

/*******************************************************************************/
/*  */
UINT16 SecterSize;												 /* ǰUÿС */  
UINT8 buf[ 64 ];

/*******************************************************************************
* Function Name  : IsDiskWriteProtect
* Description    : UǷд
*                  BulkOnlyЭԲοӴ,޸ǰ˽
*                  USB MassStorageSCSI淶 
* Input          : None
* Output         : None
* Return         : 0x00˵д,0xFF˵ֻ/д,ֵ˵Ǵ
*******************************************************************************/
UINT8 IsDiskWriteProtect( void )
{
	UINT8  i, status;
	UINT8  mIfSubClass, len;
	P_BULK_ONLY_CBW	pCbw;

	/* ȡ */
	status = CH378SendCmdDatWaitInt( CMD1H_GET_DESCR, 0x02 );
	if( status != ERR_SUCCESS )
	{
		return( status );
	}
	status = CH378ReadReqBlock( buf );							 /* ȡ */

	/* 洢豸 */
	mIfSubClass = buf[ 9 +  6 ];  								 /*  USB_CFG_DESCR_LONG.itf_descr.bInterfaceSubClass */

	/* ׼Bulk_Only_CBW */
	pCbw = (P_BULK_ONLY_CBW)buf;
	for( i = 0; i != sizeof( BULK_ONLY_CBW ); i ++ ) 
	{
		buf[ i ] = 0;  							 				 /* Ĭ0 */
	}
	pCbw -> CBW_DataLen0 = 10;  								 /* ݴ䳤 */
	pCbw -> CBW_Flag = 0x80;  									 /* ䷽Ϊ */
	if( mIfSubClass == 0x06 ) 								 
	{  
		/* SubClass-CodeΪ6 */
		pCbw -> CBW_CB_Len = 6;  								 /* ĳ */
		pCbw -> CBW_CB_Buf[ 0 ] = 0x1A;  						 /* ֽ, MODE SENSE(6) */
		pCbw -> CBW_CB_Buf[ 2 ] = 0x3F;
		pCbw -> CBW_CB_Buf[ 4 ] = 0x10;
	}
	else 														 
	{  
		/* SubClass-Code6 */
		pCbw -> CBW_CB_Len = 10;  								 /* ĳ */
		pCbw -> CBW_CB_Buf[ 0 ] = 0x5A;  						 /* ֽ, MODE SENSE(10) */
		pCbw -> CBW_CB_Buf[ 2 ] = 0x3F;
		pCbw -> CBW_CB_Buf[ 8 ] = 10;
	}
	
	/* ִ */		
	CH378WriteOfsBlock( buf, 0x00, 31 );						 /* ͨCMD40_WR_HOST_OFS_DATAдCBW */	
	status = CH378SendCmdWaitInt( CMD0H_DISK_BOC_CMD );			 /* ٷ */	
	if( status == ERR_SUCCESS )
	{
		/* ݷ,ȡ */
		len = CH378ReadReqBlock( buf );
		
		/* жǷд */	
		if ( len > 3 ) 
		{  
			/* MODE SENSEݵĳЧ */
			if( mIfSubClass == 0x06 )
			{
				i = buf[ 2 ];  									 /* MODE SENSE(6), device specific parameter */	
			}
			else
			{
				i = buf[ 3 ];  									 /* MODE SENSE(10), device specific parameter */				
			}	
			if( i & 0x80 ) 
			{
				return( 0xFF );  								 /* Uд */
			}
			else 
			{
				return( ERR_SUCCESS );  						 /* Uûд */
			}
		}
	}
	return( status );
}

/*******************************************************************************
* Function Name  : SafeRemoveDisk
* Description    : ȫƳU
*                  ڲU׼ûγUǰ, ֹûγU̶ʧ
* Input          : None
* Output         : None
* Return         : 0x00˵԰ȫƳ,˵ܰȫƳ,ֻǿƳ
*******************************************************************************/
UINT8 SafeRemoveDisk( void )
{
	UINT8  i, status;

	for( i = 0; i < 20; i ++ ) 
	{  
		/* еUǷδ׼,Ա */
		mDelaymS( 50 );
		status = CH378SendCmdWaitInt( CMD0H_DISK_READY );		 /* ѯǷ׼ */
		if( status == ERR_SUCCESS )
		{
			break;
		}
	}

	/* ֵΪ0 */
	mDelaymS( 5 );
	status = CH378SendCmdDatWaitInt( CMD1H_SET_CONFIG, 0 );  	 /* ȡ,ᵼºܶU̵LED */
	mDelaymS( 5 );
	if( ( i < 20 ) && ( status == ERR_SUCCESS ) ) 
	{
		return( ERR_SUCCESS ); 	 								 /* ɹ */
	}
	else 
	{
		return( 0xFF );
	}
}
            
/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void main( void ) 
{
	UINT8  status;
	UINT16 i;
	
	mDelaymS( 100 );  											 /* ʱ100 */
	mInitSTDIO( );  											 /* Ϊüͨڼʾ */

#if    ( IC_OP_INTERFACE_MODE == 1 )
	printf(" MCS51_CH378_PARA_HW V1.2 2015.08.28...\n");		 /* Ӳ߲ӷʽ */						 			 
#elif  ( IC_OP_INTERFACE_MODE == 2 )
	printf(" MCS51_CH378_PARA_SW V1.2 2015.08.28...\n"); 		 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
	printf(" MCS51_CH378_SPI_HW V1.2 2015.08.28...\n"); 		 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
	printf(" MCS51_CH378_SPI_SW V1.2 2015.08.28...\n");			 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
	printf(" MCS51_CH378_UART_HW V1.2 2015.08.28...\n");		 /* Ӳ첽ӷʽ */
#else
	printf(" MCS51_CH378_INTERFACE ERROR 2015.08.28...\n");
#endif

	printf( "Start\n" );
	status = mInitCH378Host( );  								 /* ʼCH378 */								 	
	mStopIfError( status );
	/* ·ʼ */

	while( 1 ) 													 
	{
		/* U̻SDǷ,ȴ */
		printf( "Wait Udisk/SD\n" );
		while( CH378DiskConnect( ) != ERR_SUCCESS ) 
		{  
			mDelaymS( 100 );
		}
		mDelaymS( 200 );  										 /* ʱ,ѡ,еUSB洢Ҫʮʱ */
		
		/* ڼ⵽USB豸,ȴ100*50mS,ҪЩMP3̫,ڼ⵽USB豸DISK_MOUNTED,
		   ȴ5*50mS,ҪDiskReady */
		for( i = 0; i < 100; i ++ ) 
		{  
			/* ȴʱ,100*50mS */
			mDelaymS( 50 );
			printf( "Ready ?\n" );
			status = CH378DiskReady( );  						 /* ʼ̲ԴǷ */
			if( status == ERR_SUCCESS ) 
			{
				break;  										 /* ׼ */
			}
			else if( status == ERR_DISK_DISCON ) 
			{
				goto UnknownUsbDevice; 							 /* ⵽Ͽ,¼Ⲣʱ */
			}
			if( CH378GetDiskStatus( ) >= DEF_DISK_MOUNTED && i >= 5 ) 
			{
				break;  										 /* еUǷδ׼,Ժ,ֻҪ佨MOUNTEDҳ5*50mS */
			}
		}
		if( status == ERR_DISK_DISCON ) 
		{  
			/* ⵽Ͽ,¼Ⲣʱ */
			printf( "Device gone\n" );
			continue;
		}
		if( CH378GetDiskStatus( ) < DEF_DISK_MOUNTED ) 
		{  
			/* δ֪USB豸,USB̡ӡ */
			printf( "Unknown device\n" );
			goto UnknownUsbDevice;
		}
		
		/* Ҫ,ԶȡݿCH378_CMD_DATA.DiskMountInq,س */
		i = CH378ReadReqBlock( buf );
		if( i == sizeof( INQUIRY_DATA ) ) 
		{  
			/* U̵ĳ̺ͲƷϢ */
			buf[ i ] = 0;
			printf( "Udisk Info: %s\n", ((P_INQUIRY_DATA)buf) -> VendorIdStr );
		}

		/* ȡǰUС(Ҫʹ) */
		SecterSize = 1 << CH378ReadVar8( VAR8_DISK_SEC_LEN );		/* ǰUÿС */  

		printf( "Check Disk Write Protect ? \n" );
		/* UǷд */
		status = IsDiskWriteProtect( );  
		if( ( status != ERR_SUCCESS ) && ( status != 0xFF ) ) 	 /* ʧ */					 
		{  			
			printf( "Again ...\n" );
			mDelaymS( 100 );
			status = IsDiskWriteProtect( );  					 /* һ */
		}
		if( status == ERR_SUCCESS ) 							 /* ǰδд,д */
		{  			
			printf( "Disk No Protect!\n" );
			printf( "Create a File\n" );
			status = CH378FileCreate( "\\NEWFILE.TXT" );  		 /* ڸĿ¼½ļ,ļѾɾ½ */
			mStopIfError( status );
			buf[ 0 ] = 'O';
			buf[ 1 ] = 'K';
			status = CH378ByteWrite( buf, 2, NULL );  			 /* ļд */
			mStopIfError( status );
			printf( "Close\n" );
			status = CH378FileClose( TRUE );  					 /* Զļ */
			mStopIfError( status );
			if( SafeRemoveDisk( ) == ERR_SUCCESS )			 	 /* ȫƳU */ 
			{  
				printf( "Safe Remove !\n" );
			}
			else 
			{
				printf( "Unsafe Remove !\n" );
			}
		}
		else if( status == 0xFF ) 
		{  
			/* д */
			printf( "Disk is Protect!\n" );
		}
		else 
		{
			mStopIfError( status );  							 /* ʾ */
		}

UnknownUsbDevice:
		printf( "Take out\n" );
		while( CH378DiskConnect( ) == ERR_SUCCESS ) 
		{  
			/* UǷ,ȴṴγ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );
	}
}


