/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.C
* Author             : MJX
* Version            : V1.20
* Date               : 2015/08/28
* Description        : CH378 ļϵͳӳ(EXAM8)
*                      USB Host File Interface for CH378
*					   TC2.0@PC, KC7.0@MCS51
*******************************************************************************/



/******************************************************************************
˵: 
    MCS-51ƬCԵUļдʾ
    ʾд,޸ļ,ѯʣռ,
    ڽADCģɼӵUļMY_ADC.TXT,ΪٶȶΪλдUļ
    ʾģʽ´,ͬʱ˲ͽϸٶ,ҪƬϵͳṩ㹻
    RAMΪļݻFILE_DATA_BUF.
    ,ҲɲCH378ڲ20K RAMΪʱ,ӶⲿƬϵͳûԴҪ
*******************************************************************************/



/*******************************************************************************/
/* ͷļ */
#include <reg52.h>
#include <stdio.h>
#include <string.h>
#include "CH378INC.H"											 /* CH378ͷļ */	
#include "HAL.H"												 /* Ӳͷļ */
#include "HAL_BASE.C"											 /* Ӳӳļ */
#include "DEBUG.H"												 /* ӳͷļ */
#include "DEBUG.C"												 /* ӳļ */

/*******************************************************************************/
/* ѡͨѶӿ */
#define	IC_OP_INTERFACE_MODE	 4							 	 /* оƬӿģʽ(1:Ӳ;  2:ģⲢ; 
                                                                    	                 3:ӲSPI; 4:ģSPI; 5:첽) */                                                                    
#if    ( IC_OP_INTERFACE_MODE == 1 )
#include "PARA_HW.C"											 /* Ӳ߲ӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 2 )
#include "PARA_SW.C"										 	 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
#include "SPI_HW.C"										 	 	 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
#include "SPI_SW.C"												 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
#include "UART_HW.C"										 	 /* Ӳ첽ӷʽ */
#else
#error: You Must Include Right Interface Operate File!!!
#endif

/*******************************************************************************/
/* ѡҪĺ */
#define EN_DISK_QUERY		  	   1							 /* ѯʣռѯӳ */
//#define EN_DIR_CREATE			   1							 /* ½༶Ŀ¼ӳ */	
#define EN_SECTOR_ACCESS   	   	   1							 /* Ϊλдļӳ */		
//#define EN_LONG_NAME	   		   1							 /* ֳ֧ļӳ */		
//#define EN_OTHER_FUNCTION   	   1							 /* ǳӳ */		

#include "FILE_SYS.H"											 /* ļϵͳͷļ */
#include "FILE_SYS.C"											 /* ļϵͳӳļ */

/*******************************************************************************/
/*  */
UINT16 SecterSize;												 /* ǰUÿС */  
UINT8 buf[ 64 ];

UINT16	total;													 /* ¼ǰFILE_DATA_BUFеݳ */
UINT32	NewSize;												 /* ʱ */
UINT8	xdata	FileDataBuf[0x4000];							 /* ļ,̫Сٶ */


/*******************************************************************************
* Function Name  : mFlushBufferToDisk
* Description    : ׼дU̵ݽмл,ϳɴݿʱͨCH378дU
*                  ĺô: ٶ(ΪݿдʱЧʸ), U(Uڲ
*                  ڴ,Ƶд)
* Input          : force---0: Զˢ(黺еݳ,д,ʱڻ);
*                          1: ǿˢ(ܻежٶд,ͨϵͳػǰӦǿд); 
* Output         : None
* Return         : None
*******************************************************************************/
void mFlushBufferToDisk( UINT8 force )
{
	UINT8  status;

	if( force ) 												 /* ǿˢ */
	{  
		status = ( total + DEF_SECTOR_SIZE - 1 ) / DEF_SECTOR_SIZE;/* еֽתΪ(DEF_SECTOR_SIZE),ȼDEF_SECTOR_SIZE-1ȷдͷ */
		if( status ) 
		{  
			/*  */
			status = CH378SecWrite( FileDataBuf, status, NULL ); /* Ϊλļд,д뻺е,ͷ */
			mStopIfError( status );
			
			/* ЩUܻ̿Ҫдݺȴһܼ,,ĳЩUзݶʧ,ÿдݺʱټ */
			mDelaymS( 1 );  									 /* дʱ,ѡ,U̲Ҫ */
			memcpy( FileDataBuf, & FileDataBuf[ total & ~ ( DEF_SECTOR_SIZE - 1 ) ], total & ( DEF_SECTOR_SIZE - 1 ) );  /* ղдU̵ͷݸƵͷ */
			total &= DEF_SECTOR_SIZE - 1;  						 /* ֻʣ¸ղдU̵ͷ,ڻΪ˷Ժ׷ */
		}
		NewSize = CH378GetFileSize( );  						 /* ȡǰļ,ûͷ,ôļDEF_SECTOR_SIZEı */
		if( total ) 
		{
			NewSize -= DEF_SECTOR_SIZE - total;  				 /* Ϊλ,ͷ,ļ(Чݵĳ) */
		}
		CH378WriteVar32( VAR32_FILE_SIZE, NewSize );  			 /* ȷĵǰļдCH378ڴ */
		printf( "Current File Size is %ld\n", NewSize );
		status = CH378SecWrite( FileDataBuf, 0, NULL );  	  	 /* д0,ʵˢļ,CH378ڴеǰļϢдU̻SD */
		mStopIfError( status );
		status = CH378SecLocate( 0xFFFFFFFF );  				 /* »صԭļβ,Ϊλ,Իļβͷ,дݽβͷ,ͷһݸڻ, */
		mStopIfError( status );
	}
	else if( total >= sizeof( FileDataBuf ) - DEF_SECTOR_SIZE ) 
	{  
		/* еݿҪ,ӦȽеԭдU */
		status = CH378SecWrite( FileDataBuf, (UINT8)( total / DEF_SECTOR_SIZE ), NULL );  /* еֽתΪ(DEF_SECTOR_SIZE),ͷȲ,Ϊλļд */
		mStopIfError( status );
		memcpy( FileDataBuf, & FileDataBuf[ total & ~ ( DEF_SECTOR_SIZE - 1 ) ], total & ( DEF_SECTOR_SIZE - 1 ) );  /* ղδдU̵ͷݸƵͷ */
		total &= DEF_SECTOR_SIZE - 1;  /* ֻʣ¸ղδдU̵ͷ */
		/* ע,˴U̻SDеļȻǰֵ,ʱͻȻϵ,ôȻϵ
		   U/SD,ļûаЩ,³Ӧó޷ȡ */
	}	
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void main( void ) 
{
	UINT8  status;
	UINT16 i;
	UINT8  month, date, hour;
	UINT16 year, adc;
		
	mDelaymS( 100 );  											 /* ʱ100 */
	mInitSTDIO( );  											 /* Ϊüͨڼʾ */

#if    ( IC_OP_INTERFACE_MODE == 1 )
	printf(" MCS51_CH378_PARA_HW V1.2 2015.08.28...\n");		 /* Ӳ߲ӷʽ */						 			 
#elif  ( IC_OP_INTERFACE_MODE == 2 )
	printf(" MCS51_CH378_PARA_SW V1.2 2015.08.28...\n"); 		 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
	printf(" MCS51_CH378_SPI_HW V1.2 2015.08.28...\n"); 		 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
	printf(" MCS51_CH378_SPI_SW V1.2 2015.08.28...\n");			 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
	printf(" MCS51_CH378_UART_HW V1.2 2015.08.28...\n");		 /* Ӳ첽ӷʽ */
#else
	printf(" MCS51_CH378_INTERFACE ERROR 2015.08.28...\n");
#endif

	printf( "Start\n" );
	mDelaymS( 200 );

	status = mInitCH378Host( );  								 /* ʼCH378 */								 	
	mStopIfError( status );
	/* ·ʼ */

	while( 1 ) 													 
	{
		/* U̻SDǷ,ȴ */
		printf( "Wait Udisk/SD\n" );
		while( CH378DiskConnect( ) != ERR_SUCCESS ) 
		{  
			mDelaymS( 100 );
		}
		mDelaymS( 200 );  										 /* ʱ,ѡ,еUSB洢Ҫʮʱ */
		
		/* ڼ⵽USB豸,ȴ100*50mS,ҪЩMP3̫,ڼ⵽USB豸DISK_MOUNTED,
		   ȴ5*50mS,ҪDiskReady */
		for( i = 0; i < 100; i ++ ) 
		{  
			/* ȴʱ,100*50mS */
			mDelaymS( 50 );
			printf( "Ready ?\n" );
			status = CH378DiskReady( );  						 /* ʼ̲ԴǷ */
			if( status == ERR_SUCCESS ) 
			{
				break;  										 /* ׼ */
			}
			else if( status == ERR_DISK_DISCON ) 
			{
				goto UnknownUsbDevice; 							 /* ⵽Ͽ,¼Ⲣʱ */
			}
			if( CH378GetDiskStatus( ) >= DEF_DISK_MOUNTED && i >= 5 ) 
			{
				break;  										 /* еUǷδ׼,Ժ,ֻҪ佨MOUNTEDҳ5*50mS */
			}
		}
		if( status == ERR_DISK_DISCON ) 
		{  
			/* ⵽Ͽ,¼Ⲣʱ */
			printf( "Device gone\n" );
			continue;
		}
		if( CH378GetDiskStatus( ) < DEF_DISK_MOUNTED ) 
		{  
			/* δ֪USB豸,USB̡ӡ */
			printf( "Unknown device\n" );
			goto UnknownUsbDevice;
		}
		
		/* Ҫ,ԶȡݿCH378_CMD_DATA.DiskMountInq,س */
		i = CH378ReadReqBlock( buf );
		if( i == sizeof( INQUIRY_DATA ) ) 
		{  
			/* U̵ĳ̺ͲƷϢ */
			buf[ i ] = 0;
			printf( "Udisk Info: %s\n", ((P_INQUIRY_DATA)buf) -> VendorIdStr );
		}

		/* ȡǰUС(Ҫʹ) */
		SectorSize = 1 << CH378ReadVar8( VAR8_DISK_SEC_LEN );	 /* ǰUÿС */  

		/* U̻SDʣռ */
		printf( "DiskQuery: " );
		status = CH378DiskQuery( (PUINT32)buf );  				 /* ѯʣռϢ, */
		mStopIfError( status );
		printf( "Free Cap: = %ld MB\n", *(PUINT32)buf / ( 1000000 / DEF_SECTOR_SIZE ) );  /* δС,1MΪֽڵλ */

		/* MY_ADC.TXTļѾݵβ,½ļ */
		printf( "Open\n" );
		status = CH378FileOpen( "/MY_ADC.TXT" );  				 /* ļ,ļڸĿ¼ */
		if( status == ERR_SUCCESS ) 							 /* ļڲѾ,ƶļָ뵽βԱ */
		{  
			NewSize = CH378GetFileSize( );  					 /* ȡǰļ,ûͷ,ôļDEF_SECTOR_SIZEı */
			printf( "Locate Tail\n" );
			status = CH378SecLocate( 0xFFFFFFFF );  			 /* ΪλƵļβ,ļβвһͷ򱻺,ôͷݽܱдݸ */
			mStopIfError( status );
			total = NewSize & ( DEF_SECTOR_SIZE - 1 );  		 /* ϴαļʱβͷ,ôȡͷֽ,ȵ */
			printf( "Read Last Tail = %d Bytes\n", total );
			if( total ) 
			{  
				/* ԭβͷ,ôȵڴ,Ա */
				CH378SetFileSize( NewSize + DEF_SECTOR_SIZE - 1 );/* ʱļ,Աȡһͷ */		
				status = CH378SecRead( FileDataBuf, 1, NULL ); 	 /* ļȡβͷ */
				mStopIfError( status );
				CH378SetFileSize( NewSize );
				status = CH378SecLocate( 0xFFFFFFFF );  		 /* »صԭļβ,дݽԭβͷ,ԭͷݸղѾڴ, */
				mStopIfError( status );
			}
		}
		else if( status == ERR_MISS_FILE ) 						 /* ûҵļ,½ļ */	
		{  
			printf( "Create\n" );
			status = CH378FileCreate( NULL );  					 /* ½ļ,ļѾɾ½,ṩļ,ղѾṩCH378FileOpen */
			mStopIfError( status );
			total = 0;  										 /* ǰûͷ */
			NewSize = 0;
		}
		else 
		{
			mStopIfError( status );  							 /* ļʱ */
		}
		printf( "Write Begin\n" );
		total += sprintf( FileDataBuf + total, "ڱ֮ǰ,ļݵĳ %ld ֽ\xd\xa", NewSize );  /* ӵβ,ۼƻڵݳ */
		mFlushBufferToDisk( 0 );  								 /* Զˢ»,黺Ƿ,д */
		printf( "Write ADC Data\n" );
		TR0 = 1;  												 /* öʱ0ļֵADC */
		for( month = 1; month != 12; month ++ ) 
		{  
			/* Ϊ԰ûʵʱʱоƬ,ѭʽģ· */
			for( date = 1; date != 30; date ++ ) 
			{  
				/* Ϊ԰ûʵʱʱоƬ,ѭʽģ */
				year = 2004;  									 /* ٶΪ2004 */
				hour = TL1 & 0x1F;  							 /* Ϊ԰ûʵʱʱоƬ,öʱ1ļʾ */
/*				adc = get_adc_data( ); */
				adc = ( (UINT16)TH0 << 8 ) | TL0;  				 /* Ϊ԰ûADC,öʱ0ļADCʾ */
				total += sprintf( FileDataBuf + total, "Year=%04d, Month=%02d, Date=%02d, Hour=%02d, ADC_data=%u\xd\xa", year, (UINT16)month, (UINT16)date, (UINT16)hour, adc );  /* ݸʽΪһַ */
				if( month == 6 && ( date & 0x0F ) == 0 ) 
				{
					mFlushBufferToDisk( 1 ); 	 				 /* ǿˢ»,ǿˢ»,ͻȻϵԼݶʧ */
				}
				else 
				{
					mFlushBufferToDisk( 0 );  					 /* Զˢ»,黺Ƿ,д */
				}
				printf( "Current Total is %d\n", total );  	   	 /* ڼؼ */
			}
		}
		printf( "Write End\n" );
		total += sprintf( FileDataBuf + total, " ********************************* " );  /* ӵβ,ۼƻڵݳ */
		total += sprintf( FileDataBuf + total, "εADCݵ˽,򼴽˳\xd\xa" );  /* ӵβ,ۼƻڵݳ */
		mFlushBufferToDisk( 1 );  								 /* ǿˢ»,ΪϵͳҪ˳,Աǿˢ */
		printf( "Close\n" );
		status = CH378FileClose( FALSE );  						 /* رļ,ģʽͨԶļ,Ϊǿˢ»ʱѾļ,ﲻҪԶļ */
		mStopIfError( status );		
		
UnknownUsbDevice:
		printf( "Take out\n" );
		while( CH378DiskConnect( ) == ERR_SUCCESS ) 
		{  
			/* UǷ,ȴṴγ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );
	}
}


