/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.C
* Author             : MJX
* Version            : V1.20
* Date               : 2015/08/28
* Description        : CH378 ļϵͳӳ(EXAM9)
*                      USB Host File Interface for CH378
*					   TC2.0@PC, KC7.0@MCS51
*******************************************************************************/



/******************************************************************************
˵: 
    MCS-51ƬCԵUļдʾ
    ʾĿ¼,Լ򿪶༶Ŀ¼µļĿ¼
*******************************************************************************/



/*******************************************************************************/
/* ͷļ */
#include <reg52.h>
#include <stdio.h>
#include <string.h>
#include "CH378INC.H"											 /* CH378ͷļ */	
#include "HAL.H"												 /* Ӳͷļ */
#include "HAL_BASE.C"											 /* Ӳӳļ */
#include "DEBUG.H"												 /* ӳͷļ */
#include "DEBUG.C"												 /* ӳļ */

/*******************************************************************************/
/* ѡͨѶӿ */
#define	IC_OP_INTERFACE_MODE	 2							 	 /* оƬӿģʽ(1:Ӳ;  2:ģⲢ; 
                                                                    	                 3:ӲSPI; 4:ģSPI; 5:첽) */                                                                    
#if    ( IC_OP_INTERFACE_MODE == 1 )
#include "PARA_HW.C"											 /* Ӳ߲ӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 2 )
#include "PARA_SW.C"										 	 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
#include "SPI_HW.C"										 	 	 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
#include "SPI_SW.C"												 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
#include "UART_HW.C"										 	 /* Ӳ첽ӷʽ */
#else
#error: You Must Include Right Interface Operate File!!!
#endif

/*******************************************************************************/
/* ѡҪĺ */
//#define EN_DISK_QUERY		  	   1							 /* ѯʣռѯӳ */
#define EN_DIR_CREATE			   1							 /* ½༶Ŀ¼ӳ */	
//#define EN_SECTOR_ACCESS   	   1							 /* Ϊλдļӳ */		
//#define EN_LONG_NAME	   		   1							 /* ֳ֧ļӳ */		
//#define EN_OTHER_FUNCTION   	   1							 /* ǳӳ */		

#include "FILE_SYS.H"											 /* ļϵͳͷļ */
#include "FILE_SYS.C"											 /* ļϵͳӳļ */

/*******************************************************************************/
/*  */
UINT16 SecterSize;												 /* ǰUÿС */  
UINT8  idata buf[ 64 ];											 /* ݻ */	

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void main( void ) 
{
	UINT8  status;
	UINT16 i;
	
	mDelaymS( 100 );  											 /* ʱ100 */
	mInitSTDIO( );  											 /* Ϊüͨڼʾ */

#if    ( IC_OP_INTERFACE_MODE == 1 )
	printf(" MCS51_CH378_PARA_HW V1.2 2015.08.28...\n");		 /* Ӳ߲ӷʽ */						 			 
#elif  ( IC_OP_INTERFACE_MODE == 2 )
	printf(" MCS51_CH378_PARA_SW V1.2 2015.08.28...\n"); 		 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
	printf(" MCS51_CH378_SPI_HW V1.2 2015.08.28...\n"); 		 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
	printf(" MCS51_CH378_SPI_SW V1.2 2015.08.28...\n");			 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
	printf(" MCS51_CH378_UART_HW V1.2 2015.08.28...\n");		 /* Ӳ첽ӷʽ */
#else
	printf(" MCS51_CH378_INTERFACE ERROR 2015.08.28...\n");
#endif

	printf( "Start\n" );
	mDelaymS( 200 );

	status = mInitCH378Host( );  								 /* ʼCH378 */								 	
	mStopIfError( status );
	/* ·ʼ */

	while( 1 ) 													 
	{
		/* U̻SDǷ,ȴ */
		printf( "Wait Udisk/SD\n" );
		while( CH378DiskConnect( ) != ERR_SUCCESS ) 
		{  
			mDelaymS( 100 );
		}
		mDelaymS( 200 );  										 /* ʱ,ѡ,еUSB洢Ҫʮʱ */
		
		/* ڼ⵽USB豸,ȴ100*50mS,ҪЩMP3̫,ڼ⵽USB豸DISK_MOUNTED,
		   ȴ5*50mS,ҪDiskReady */
		for( i = 0; i < 100; i ++ ) 
		{  
			/* ȴʱ,100*50mS */
			mDelaymS( 50 );
			printf( "Ready ?\n" );
			status = CH378DiskReady( );  						 /* ʼ̲ԴǷ */
			if( status == ERR_SUCCESS ) 
			{
				break;  										 /* ׼ */
			}
			else if( status == ERR_DISK_DISCON ) 
			{
				goto UnknownUsbDevice; 							 /* ⵽Ͽ,¼Ⲣʱ */
			}
			if( CH378GetDiskStatus( ) >= DEF_DISK_MOUNTED && i >= 5 ) 
			{
				break;  										 /* еUǷδ׼,Ժ,ֻҪ佨MOUNTEDҳ5*50mS */
			}
		}
		if( status == ERR_DISK_DISCON ) 
		{  
			/* ⵽Ͽ,¼Ⲣʱ */
			printf( "Device gone\n" );
			continue;
		}
		if( CH378GetDiskStatus( ) < DEF_DISK_MOUNTED ) 
		{  
			/* δ֪USB豸,USB̡ӡ */
			printf( "Unknown device\n" );
			goto UnknownUsbDevice;
		}
		
		/* Ҫ,ԶȡݿCH378_CMD_DATA.DiskMountInq,س */
		i = CH378ReadReqBlock( buf );
		if( i == sizeof( INQUIRY_DATA ) ) 
		{  
			/* U̵ĳ̺ͲƷϢ */
			buf[ i ] = 0;
			printf( "Udisk Info: %s\n", ((P_INQUIRY_DATA)buf) -> VendorIdStr );
		}

		/* ȡǰUС(Ҫʹ) */
		SecterSize = 1 << CH378ReadVar8( VAR8_DISK_SEC_LEN );		/* ǰUÿС */  

		/* ʾ½һĿ¼ */
		printf( "Create Level 1 Directory /YEAR2008 \n" );
		status = CH378DirCreate( "/YEAR2008" );  				 /* ½ߴĿ¼,Ŀ¼ڸĿ¼ */
		if( status == ERR_FOUND_NAME ) 
		{
			printf( "Found A File With Same Name\n" );
		}
		mStopIfError( status );
		CH378FileClose( FALSE );  								 /* رĿ¼ */

		/* ʾ½Ŀ¼ */
		printf( "Create Level 2 Directory /YEAR2008/MONTH05 \n" );
		/* Ŀ¼YEAR2008Ŀ¼,YEAR2008Ŀ¼ȴ */ 
		status = CH378DirCreate( "/YEAR2008/MONTH05" );  		 /* ½ߴĿ¼,Ŀ¼ڶ༶Ŀ¼ */
		if( status == ERR_FOUND_NAME ) 
		{
			printf( "Found A File With Same Name\n" );
		}
		mStopIfError( status );
//		CH378FileClose( FALSE );  								 /* ʱرĿ¼,ΪҪ½ߴ򿪵Ŀ¼½ļ */

		/* Ŀ¼½ߴ򿪳ɹ,ʾĿ¼½һļ, 
		   ַ: */  	      
 		printf( "Create New File /YEAR2008/MONTH05/DEMO2008.TXT \n" );
	
		/* һֱӲCH378FileCreateڵǰĿ¼½ļ(ǰϼĿ¼ûйر) */
		status = CH378FileCreate( "DEMO2008.TXT" );  			 /* ڵǰĿ¼½ļ,ļѾɾ½ */
		mStopIfError( status );

		/* ֱӲCH378FileCreateͨ·½ļ */
//		status = CH378FileCreate( "/YEAR2008/MONTH05/DEMO2008.TXT" );  	
//		mStopIfError( status );

		printf( "Write Some Data To File\n" );
		strcpy( buf, "This is ʾ\xd\xa" );
		status = CH378ByteWrite( buf, strlen(buf), NULL );  	 /* ֽΪλǰλдݿ */
		mStopIfError( status );

		printf( "Close\n" );
		status = CH378FileClose( TRUE );  						 /* رļ,Զļ */
		mStopIfError( status );

		/* ʾ򿪶༶Ŀ¼µļ */
		printf( "Open File /YEAR2008/MONTH05/DEMO2008.TXT \n" );
		status = CH378FileOpen( "/YEAR2008/MONTH05/DEMO2008.TXT" );/* ֱӴ򿪶༶Ŀ¼µļ */
		mStopIfError( status );

		printf( "Close\n" );
		status = CH378FileClose( FALSE );  						 /* رļ */
		mStopIfError( status );
		
UnknownUsbDevice:
		printf( "Take out\n" );
		while( CH378DiskConnect( ) == ERR_SUCCESS ) 
		{  
			/* UǷ,ȴṴγ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );
	}
}


