/********************************** (C) COPYRIGHT *******************************
* File Name          : SPI_SW.C
* Author             : MJX
* Version            : V1.2
* Date               : 2015/08/28
* Description        : CH378оƬ ģSPIӵӲ V1.2
*                      ṩI/Oӿӳ
*******************************************************************************/



/*******************************************************************************/
/* ͷļ */
#include "HAL.H"

/*******************************************************************************/
/* Ӳغ궨 */
/* еӲӷʽ(ʵӦõ·Բ޸弰ӳ) */
/* Ƭ               CH378оƬ
        P1.4                       SCS
        P1.5                       SDI
        P1.6                       SDO
        P1.7                       SCK      */
sbit	P14			 =			   P1^4;
sbit	P15			 =			   P1^5;
sbit	P16			 =			   P1^6;
sbit	P17			 =			   P1^7;
#define	CH378_SPI_SCS			   P14							 /* ٶCH378SCS */
#define	CH378_SPI_SDI			   P15							 /* ٶCH378SDI */
#define	CH378_SPI_SDO			   P16							 /* ٶCH378SDO */
#define	CH378_SPI_SCK			   P17						 	 /* ٶCH378SCK */

#define CH378_INT_WIRE			   INT0							 /* ٶCH378INT#,δôҲͨѯжSDO״̬ʵ */

/*******************************************************************************
* Function Name  : CH378_PORT_INIT
* Description    : CH378˿ڳʼ
*                  ʹģSPIдʱ,Խгʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH378_PORT_INIT( void )
{
	/* ӲSPIӿ,ôʹmode3(CPOL=1&CPHA=1)mode0(CPOL=0&CPHA=0),
	   CH378ʱز,½,λǸλǰ */
	CH378_SPI_SCS = 1;  										 /* ֹSPIƬѡ */
	CH378_SPI_SCK = 1;  										 /* ĬΪߵƽ,SPIģʽ3,ҲSPIģʽ0,ģ޸ */
	/* ˫I/OģSPIӿ,ôڴSPI_SCS,SPI_SCK,SPI_SDIΪ,SPI_SDOΪ뷽 */
}

/*******************************************************************************
* Function Name  : mDelay0_5uS
* Description    : ʱ0.5΢
*                  ʱ0.5uS,ݵƬƵ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mDelay0_5uS( void )
{
}

/*******************************************************************************
* Function Name  : Spi378OutByte
* Description    : SPI8λ
* Input          : d---SPI8λ
* Output         : None
* Return         : None
*******************************************************************************/
void Spi378OutByte( UINT8 d ) 
{  
	/* ӲSPIӿ,ӦȽдSPIݼĴ,ȻѯSPI״̬ĴԵȴSPIֽڴ */
	UINT8  i;

	for( i = 0; i < 8; i ++ ) 
	{
		CH378_SPI_SCK = 0;
		if( d & 0x80 ) 
		{
			CH378_SPI_SDI = 1;
		}
		else 
		{
			CH378_SPI_SDI = 0;
		}
		d <<= 1;  												 /* λǸλǰ */
		CH378_SPI_SCK = 1;  									 /* CH378ʱز */
	}
}

/*******************************************************************************
* Function Name  : Spi378InByte
* Description    : SPI8λ
* Input          : None
* Output         : None
* Return         : SPIȡ8λ
*******************************************************************************/
UINT8 Spi378InByte( void )  
{  
	/* ӲSPIӿ,ӦȲѯSPI״̬ĴԵȴSPIֽڴ,ȻSPIݼĴ */
	UINT8  i, d;
	
	d = 0;
	for( i = 0; i < 8; i ++ ) 
	{
		CH378_SPI_SCK = 0;  									 /* CH378ʱ½ */
		d <<= 1;  												 /* λǸλǰ */
		if( CH378_SPI_SDO ) 
		{
			d++;
		}
		CH378_SPI_SCK = 1;
	}
	return( d );
}

#define	xEndCH378Cmd( )			   { CH378_SPI_SCS = 1; }  		 /* SPIƬѡЧ,CH378,SPIӿڷʽ */

/*******************************************************************************
* Function Name  : xWriteCH378Cmd
* Description    : CH378д
* Input          : mCmd---ҪдCH378
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH378Cmd( UINT8 mCmd ) 
{
	CH378_SPI_SCS = 1;  										 /* ֹ֮ǰδͨxEndCH378CmdֹSPIƬѡ */
	mDelay0_5uS( );

	/* ˫I/OģSPIӿ,ôȷѾSPI_SCS,SPI_SCK,SPI_SDIΪ,SPI_SDOΪ뷽 */
	CH378_SPI_SCS = 0;  										 /* SPIƬѡЧ */
	Spi378OutByte( mCmd );  									 /*  */
	mDelay0_5uS( ); 
	mDelay0_5uS( ); 
	mDelay0_5uS( );  											 /* ʱ1.5uSȷдڴ1.5uS,һе״̬ѯ */
}

#ifdef	FOR_LOW_SPEED_MCU  									 	 /* Ҫʱ */

#define	xWriteCH378Data( d )	   { Spi378OutByte( d ); }  	 /* CH378д */
#define	xReadCH378Data( )		   ( Spi378InByte( ) )  		 /* CH378 */

#else

/*******************************************************************************
* Function Name  : xWriteCH378Data
* Description    : CH378д
* Input          : mData---ҪдCH378
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH378Data( UINT8 mData )  
{
	Spi378OutByte( mData );
}

/*******************************************************************************
* Function Name  : xReadCH378Data
* Description    : CH378
* Input          : None
* Output         : None
* Return         : ضȡ
*******************************************************************************/
UINT8 xReadCH378Data( void )  
{
	return( Spi378InByte( ) );
}

#endif

/*******************************************************************************
* Function Name  : Query378Interrupt
* Description    : ѯCH378ж(INT#͵ƽ)
* Input          : None
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 Query378Interrupt( void )
{
	/* CH378жֱӲѯж */
	/* δCH378жѯжSDO״̬ */
#ifdef	CH378_INT_WIRE
	return( CH378_INT_WIRE ? FALSE : TRUE );  
#else
	return( CH378_SPI_SDO ? FALSE : TRUE );  
#endif
}

/*******************************************************************************
* Function Name  : mInitCH378Host
* Description    : ʼCH378
* Input          : None
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 mInitCH378Host( void ) 
{
	UINT8  res;

	/* CH378Ƿ */
	CH378_PORT_INIT( );  										 /* ӿӲʼ */
	xWriteCH378Cmd( CMD11_CHECK_EXIST );  						 /* ԵƬCH378֮ͨѶӿ */
	xWriteCH378Data( 0x65 );
	res = xReadCH378Data( );
	xEndCH378Cmd( );
	if( res != 0x9A ) 
	{
		/* ͨѶӿڲ,ԭ:ӿ쳣,豸Ӱ(ƬѡΨһ),ڲ,һֱڸλ,񲻹 */
		return( ERR_USB_UNKNOWN );  
	}	
	
	/* CH378ģʽ */	
	xWriteCH378Cmd( CMD11_SET_USB_MODE );  					 	 /* 豸USBģʽ */
//	xWriteCH378Data( 0x04 );									 /* SD */
	xWriteCH378Data( 0x07 );									 /* USB洢豸 */

	/* ȴģʽ,ڲSDҪ10mSʱ,ڲUSB豸Ҫ35mSʱ */	
	mDelaymS( 50 );											 
	res = xReadCH378Data( );
	xEndCH378Cmd( );
#ifndef	CH378_INT_WIRE
#ifdef	CH378_SPI_SDO
	xWriteCH378Cmd( CMD20_SET_SDO_INT );  						 /* SPISDOŵжϷʽ */
	xWriteCH378Data( 0x16 );
	xWriteCH378Data( 0x01 );  									 /* SDOSCSƬѡЧʱж */
	xEndCH378Cmd( );
#endif
#endif
	if( res == CMD_RET_SUCCESS ) 
	{
		return( ERR_SUCCESS );
	}
	else 
	{
		return( ERR_USB_UNKNOWN );  							 /* ģʽ */
	}
}
